USE MASTER
IF EXISTS (SELECT * FROM SYSDATABASES WHERE NAME='pr_cs_sampleDB')
DROP DATABASE pr_cs_sampleDB
CREATE DATABASE pr_cs_sampleDB
GO
USE pr_cs_sampleDB
CREATE TABLE books
(
	BOOK_ID	VARCHAR(6)	PRIMARY KEY,
	TITLE	VARCHAR(80)	NOT NULL,
	TYPE	CHAR(12)	NOT NULL,
	PRICE	MONEY	NULL,
	PUBDATE	DATETIME	NOT NULL DEFAULT (GETDATE())
)
CREATE TABLE authors
(
	AUTHOR_ID	VARCHAR(2)	PRIMARY KEY,
	NAME	VARCHAR(80)	NOT NULL,
)
CREATE TABLE bookauthor
(
	AUTHOR_ID	VARCHAR(2)	REFERENCES authors(AUTHOR_ID),
	BOOK_ID	VARCHAR(6)	REFERENCES books(BOOK_ID)
	CONSTRAINT PKBA PRIMARY KEY CLUSTERED(AUTHOR_ID, BOOK_ID)
)
INSERT INTO books VALUES ('000001','11󗝘_','Ȋw',3200,'2011-1-20');
INSERT INTO books VALUES ('000002','َw','Ȋw',4500,'2011-7-15');
INSERT INTO books VALUES ('000003','y̓VfBK[̔LłB','',700,'2011-8-10');
INSERT INTO authors VALUES ('01','hCV^C');
INSERT INTO authors VALUES ('02','ȂL');
INSERT INTO bookauthor VALUES ('01','000001');
INSERT INTO bookauthor VALUES ('01','000002');
INSERT INTO bookauthor VALUES ('02','000002');
INSERT INTO bookauthor VALUES ('02','000003');